Subject: Re: [PATCH][RESEND] Fix checksum related BUG in l2tp_ppp receive path

From: Tom Parkin <[email-masked]>
Date: Wed, 29 May 2013 17:49:24 +0100

Hi Jana,

Thanks for the patch, and sorry for missing it the first time around!

On Tue, May 28, 2013 at 09:03:24AM +0200, Jana Saout wrote:
> Interestingly, the PPP over L2TP (with xl2tpd) is working fine when
> using my Linux client, but a simple ping from my Android phone causes
> the BUG on the first packet.  It happens on the L2TP -> PPP path, as the
> ping request never leaves the ppp devices to the local network.
> 
> What *might* be different from other setups, is that the machine on
> which the L2TP packets are decapsulated is a Xen VM, so the packets
> arrive with CHECKSUM_PARTIAL set.

Could you advise what Android client you're using?  I'd like to
attempt to reproduce this here.  We do a lot of L2TP testing in VM
environments (albeit not Xen), so I'm interested as to why we've not
hit this.

> I believe that since the L2TP checksum has already been checked and
> everything, the decapsulated packet is supposedly "fine" and I also saw
> the following line in l2tp_eth.c:
> 
>         /* checksums verified by L2TP */
>         skb->ip_summed = CHECKSUM_NONE;
> 
> which sounds to mike like the right thing to do, so I modified
> l2tp_ppp.c accordingly and voila - no more crashes.  In case it helps, I
> would like to share that patch for inclusion or, in case I'm wrong, to
> ask you to find the correct fix. :)

I think your analysis is correct, but I'm not sure whether setting
skb->ip_summed to CHECKSUM_NONE is the right thing to do.  It seems
like this would disable checksumming for the ICMP echo response.
Although that may avoid the BUG, it may not be entirely ideal
behaviour.

I'll have a dig into the other tunnelling protocol implementation and
see what they do.
-- 
Tom Parkin
Katalix Systems Ltd
http://www.katalix.com
Catalysts for your Embedded Linux software development